//
//  ViewController.swift
//  Contacts
//
//  Created by Fabian Mecklenburg on 10.10.20.
//

import UIKit

class ViewController: UIViewController, UITableViewDataSource {
    
    var model = Model()
   
    override func viewDidLoad() {
        super.viewDidLoad()
        // Do any additional setup after loading the view.
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        let keys = model.contacts.keys
        return keys.count
    }
    
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        let keys = model.contacts.keys
        let sortedKeys = keys.sorted(by: <)
        
        let key = sortedKeys[section]
        let contacts = model.contacts[key]
        
        return contacts?.count ?? 0
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        let cell = tableView.dequeueReusableCell(withIdentifier: "myOwnCell", for: indexPath) as! ContactTableViewCell
        
        let keys = model.contacts.keys
        let sortedKeys = keys.sorted(by: <)
        
        let key = sortedKeys[indexPath.section]
        let contacts = model.contacts[key]
        
        let contact = contacts?[indexPath.row]
        cell.contact = contact

        return cell
    }
    
    func tableView(_ tableView: UITableView, titleForHeaderInSection section: Int) -> String? {
        let keys = model.contacts.keys
        let sortedKeys = keys.sorted(by: <)
        return sortedKeys[section]
    }

}

